=== icons/CMakeLists.txt ===
ecm_install_icons(
ICONS
128-apps-labplot.png
150-apps-labplot.png
16-apps-labplot.png
22-apps-labplot.png
256-apps-labplot.png
310-apps-labplot.png
32-apps-labplot.png
44-apps-labplot.png
48-apps-labplot.png
512-apps-labplot.png
64-apps-labplot.png
sc-apps-labplot.svgz
DESTINATION ${KDE_INSTALL_ICONDIR}/)
install(FILES org.kde.labplot.svg DESTINATION ${KDE_INSTALL_FULL_ICONDIR}/hicolor/scalable/apps/)
