=== src/CMakeLists.txt ===
find_package(SharedMimeInfo REQUIRED)
set(FRONTEND_DIR "${CMAKE_CURRENT_LIST_DIR}/frontend")
set(BACKEND_DIR "${CMAKE_CURRENT_LIST_DIR}/backend")
set(CANTOR_DIR "${CMAKE_CURRENT_LIST_DIR}/cantor")
set(TOOLS_DIR "${CMAKE_CURRENT_LIST_DIR}/tools")
set(CMAKE_AUTOMOC ON)
set(SRC_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)

set(GUI_SOURCES
    ${FRONTEND_DIR}/AboutDialog.cpp
    ${FRONTEND_DIR}/DatasetModel.cpp
    ${FRONTEND_DIR}/GuiObserver.cpp
    ${FRONTEND_DIR}/GuiTools.cpp
    ${FRONTEND_DIR}/HistoryDialog.cpp
    ${FRONTEND_DIR}/MainWin.cpp
    ${FRONTEND_DIR}/PlotTemplateDialog.cpp
    ${FRONTEND_DIR}/ProjectExplorer.cpp
    ${FRONTEND_DIR}/SettingsDialog.cpp
    ${FRONTEND_DIR}/SettingsGeneralPage.cpp
    ${FRONTEND_DIR}/SettingsNotebookPage.cpp
    ${FRONTEND_DIR}/SettingsSpreadsheetPage.cpp
    ${FRONTEND_DIR}/SettingsWorksheetPage.cpp
    ${FRONTEND_DIR}/SettingsDatasetsPage.cpp
    ${FRONTEND_DIR}/SettingsPage.h
    ${FRONTEND_DIR}/TemplateHandler.cpp
    ${FRONTEND_DIR}/ThemeHandler.cpp
    ${FRONTEND_DIR}/examples/ExamplesDialog.cpp
    ${FRONTEND_DIR}/examples/ExamplesManager.cpp
    ${FRONTEND_DIR}/examples/ExamplesWidget.cpp
#     ${FRONTEND_DIR}/welcomescreen/WelcomeScreenHelper.cpp
    ${FRONTEND_DIR}/colormaps/ColorMapsWidget.cpp
    ${FRONTEND_DIR}/colormaps/ColorMapsDialog.cpp
    ${FRONTEND_DIR}/core/ContentDockWidget.cpp
    ${FRONTEND_DIR}/datapicker/DatapickerView.cpp
    ${FRONTEND_DIR}/datapicker/DatapickerImageView.cpp
    ${FRONTEND_DIR}/datasources/AsciiOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/CANOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/BinaryOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/DatabaseManagerDialog.cpp
    ${FRONTEND_DIR}/datasources/DatabaseManagerWidget.cpp
    ${FRONTEND_DIR}/datasources/DatasetMetadataManagerDialog.cpp
    ${FRONTEND_DIR}/datasources/DatasetMetadataManagerWidget.cpp
    ${FRONTEND_DIR}/datasources/OdsOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/XLSXOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/HDF5OptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/ImageOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/ImportDatasetWidget.cpp
    ${FRONTEND_DIR}/datasources/ImportDatasetDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportWarningsDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportFileWidget.cpp
    ${FRONTEND_DIR}/datasources/ImportFileDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportKaggleDatasetWidget.cpp
    ${FRONTEND_DIR}/datasources/ImportKaggleDatasetDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportOriginLayersDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportProjectDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportSQLDatabaseDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportSQLDatabaseWidget.cpp
    ${FRONTEND_DIR}/datasources/MatioOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/NetCDFOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/ROOTOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/FITSOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/JsonOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/McapOptionsWidget.cpp
    ${FRONTEND_DIR}/dockwidgets/BaseDock.cpp
    ${FRONTEND_DIR}/dockwidgets/AspectDock.cpp
    ${FRONTEND_DIR}/dockwidgets/AxisDock.cpp
    ${FRONTEND_DIR}/dockwidgets/CursorDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ImageDock.cpp
    ${FRONTEND_DIR}/dockwidgets/InfoElementDock.cpp
    ${FRONTEND_DIR}/dockwidgets/NoteDock.cpp
    ${FRONTEND_DIR}/dockwidgets/CartesianPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/CartesianPlotLegendDock.cpp
    ${FRONTEND_DIR}/dockwidgets/HistogramDock.cpp
    ${FRONTEND_DIR}/dockwidgets/BarPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/BoxPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/CustomPointDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ColumnDock.cpp
    ${FRONTEND_DIR}/dockwidgets/KDEPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/LiveDataDock.cpp
    ${FRONTEND_DIR}/dockwidgets/LollipopPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/MatrixDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ProcessBehaviorChartDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ProjectDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ReferenceLineDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ReferenceRangeDock.cpp
    ${FRONTEND_DIR}/dockwidgets/RunChartDock.cpp
    ${FRONTEND_DIR}/dockwidgets/SpreadsheetDock.cpp
    ${FRONTEND_DIR}/dockwidgets/StatisticsSpreadsheetDock.cpp
    ${FRONTEND_DIR}/dockwidgets/QQPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYAnalysisCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYEquationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYFunctionCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYDataReductionCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYDifferentiationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYIntegrationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYInterpolationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYSmoothCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYFitCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYFourierFilterCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYFourierTransformCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYHilbertTransformCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYConvolutionCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYCorrelationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/WorksheetDock.cpp
    ${FRONTEND_DIR}/matrix/MatrixFunctionDialog.cpp
    ${FRONTEND_DIR}/matrix/MatrixView.cpp
    ${FRONTEND_DIR}/note/NoteView.cpp
    ${FRONTEND_DIR}/spreadsheet/PlotDataDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/EquidistantValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/ExportSpreadsheetDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/AddSubtractValueDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/AddValueLabelDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/BatchEditValueLabelsDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/DropValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/FlattenColumnsDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/FormattingHeatmapDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/GoToDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/FunctionValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/RandomValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/RescaleDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/SampleValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/SearchReplaceWidget.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetCommentsHeaderModel.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetHeaderView.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetSparkLineHeaderModel.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetItemDelegate.cpp
    ${FRONTEND_DIR}/spreadsheet/SparklineRunnable.h
    ${FRONTEND_DIR}/spreadsheet/SparklineRunnable.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetView.cpp
    ${FRONTEND_DIR}/spreadsheet/SortDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/StatisticsColumnWidget.cpp
    ${FRONTEND_DIR}/spreadsheet/StatisticsDialog.cpp
    ${FRONTEND_DIR}/worksheet/ExportWorksheetDialog.cpp
    ${FRONTEND_DIR}/worksheet/GridDialog.cpp
    ${FRONTEND_DIR}/worksheet/PresenterWidget.cpp
    ${FRONTEND_DIR}/worksheet/SlidingPanel.cpp
    ${FRONTEND_DIR}/worksheet/WorksheetPreviewWidget.cpp
    ${FRONTEND_DIR}/worksheet/WorksheetView.cpp
    ${FRONTEND_DIR}/widgets/BackgroundWidget.cpp
    ${FRONTEND_DIR}/widgets/ConstantsWidget.cpp
    ${FRONTEND_DIR}/widgets/ThemesComboBox.cpp
    ${FRONTEND_DIR}/widgets/ThemesWidget.cpp
    ${FRONTEND_DIR}/widgets/ExpressionTextEdit.cpp
    ${FRONTEND_DIR}/widgets/FitOptionsWidget.cpp
    ${FRONTEND_DIR}/widgets/FitParametersWidget.cpp
    ${FRONTEND_DIR}/widgets/FunctionsWidget.cpp
    ${FRONTEND_DIR}/widgets/LabelWidget.cpp
    ${FRONTEND_DIR}/widgets/ErrorBarWidget.cpp
    ${FRONTEND_DIR}/widgets/LineWidget.cpp
    ${FRONTEND_DIR}/widgets/SymbolWidget.cpp
    ${FRONTEND_DIR}/widgets/ValueWidget.cpp
    ${FRONTEND_DIR}/widgets/DatapickerImageWidget.cpp
    ${FRONTEND_DIR}/widgets/DatapickerCurveWidget.cpp
    ${FRONTEND_DIR}/widgets/FITSHeaderEditWidget.cpp
    ${FRONTEND_DIR}/widgets/FITSHeaderEditNewKeywordDialog.cpp
    ${FRONTEND_DIR}/widgets/FITSHeaderEditAddUnitDialog.cpp
    ${FRONTEND_DIR}/widgets/FITSHeaderEditDialog.cpp
    ${FRONTEND_DIR}/widgets/ResizableTextEdit.cpp
    ${FRONTEND_DIR}/widgets/TimedLineEdit.cpp
    ${FRONTEND_DIR}/widgets/TreeViewComboBox.cpp
    ${FRONTEND_DIR}/widgets/qxtspanslider.cpp
    ${FRONTEND_DIR}/widgets/MemoryWidget.cpp
    ${FRONTEND_DIR}/widgets/DateTimeSpinBox.cpp
    ${FRONTEND_DIR}/widgets/NumberSpinBox.cpp
    ${FRONTEND_DIR}/widgets/UTCDateTimeEdit.cpp
    ${FRONTEND_DIR}/workbook/WorkbookView.cpp
)

if(Qt${QT_VERSION_MAJOR}Mqtt_FOUND)
    list(APPEND GUI_SOURCES ${FRONTEND_DIR}/datasources/MQTTConnectionManagerWidget.cpp)
    list(APPEND GUI_SOURCES ${FRONTEND_DIR}/datasources/MQTTConnectionManagerDialog.cpp)
    list(APPEND GUI_SOURCES ${FRONTEND_DIR}/datasources/MQTTErrorWidget.cpp)
    list(APPEND GUI_SOURCES ${FRONTEND_DIR}/datasources/MQTTSubscriptionWidget.cpp)
endif()

if(APPLE)
  list(APPEND GUI_SOURCES ${FRONTEND_DIR}/worksheet/PresenterWidget_mac.mm)
endif()

set(GUI_QRC
    ${FRONTEND_DIR}/labplot.qrc
)

set(UI_SOURCES
    ${FRONTEND_DIR}/ui/colormapswidget.ui
    ${FRONTEND_DIR}/ui/constantswidget.ui
    ${FRONTEND_DIR}/ui/PlotTemplateDialog.ui
    ${FRONTEND_DIR}/ui/exampleswidget.ui
    ${FRONTEND_DIR}/ui/functionswidget.ui
    ${FRONTEND_DIR}/ui/fitoptionswidget.ui
    ${FRONTEND_DIR}/ui/fitparameterswidget.ui
    ${FRONTEND_DIR}/ui/labelwidget.ui
    ${FRONTEND_DIR}/ui/symbolwidget.ui
    ${FRONTEND_DIR}/ui/settingsnotebookpage.ui
    ${FRONTEND_DIR}/ui/settingsgeneralpage.ui
    ${FRONTEND_DIR}/ui/settingsspreadsheetpage.ui
    ${FRONTEND_DIR}/ui/settingsworksheetpage.ui
#     ${FRONTEND_DIR}/ui/settingswelcomepage.ui
    ${FRONTEND_DIR}/ui/settingsdatasetspage.ui
    ${FRONTEND_DIR}/ui/settingsprintingpage.ui
    ${FRONTEND_DIR}/ui/datasources/asciioptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/CANOptionsWidget.ui
    ${FRONTEND_DIR}/ui/datasources/binaryoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/databasemanagerwidget.ui
    ${FRONTEND_DIR}/ui/datasources/datasetmetadatamanagerwidget.ui
    ${FRONTEND_DIR}/ui/datasources/hdf5optionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/imageoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/importdatasetwidget.ui
    ${FRONTEND_DIR}/ui/datasources/importkaggledatasetwidget.ui
    ${FRONTEND_DIR}/ui/datasources/importfilewidget.ui
    ${FRONTEND_DIR}/ui/datasources/importoriginlayersdialog.ui
    ${FRONTEND_DIR}/ui/datasources/importwarningsdialog.ui
    ${FRONTEND_DIR}/ui/datasources/importprojectwidget.ui
    ${FRONTEND_DIR}/ui/datasources/importsqldatabasewidget.ui
    ${FRONTEND_DIR}/ui/datasources/matiooptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/netcdfoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/rootoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/fitsoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/jsonoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/mcapoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/odsoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/xlsxoptionswidget.ui
    ${FRONTEND_DIR}/ui/dockwidgets/aspectdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/axisdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/backgroundwidget.ui
    ${FRONTEND_DIR}/ui/dockwidgets/cursordock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/infoelementdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/cartesianplotdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/cartesianplotlegenddock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/histogramdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/barplotdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/boxplotdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/columndock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/custompointdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/errorbarwidget.ui
    ${FRONTEND_DIR}/ui/dockwidgets/imagedock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/kdeplotdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/linewidget.ui
    ${FRONTEND_DIR}/ui/dockwidgets/livedatadock.ui
