=== data/pics/CMakeLists.txt ===
ecm_install_icons(
ICONS
sc-apps-labplot-1x-zoom.svg
sc-apps-labplot-2x-zoom.svg
sc-apps-labplot-3x-zoom.svg
sc-apps-labplot-4x-zoom.svg
sc-apps-labplot-5x-zoom.svg
sc-apps-labplot-auto-scale-all.svg
sc-apps-labplot-auto-scale-x.svg
sc-apps-labplot-auto-scale-y.svg
sc-apps-labplot-axis-horizontal.svg
sc-apps-labplot-axis-vertical.svg
sc-apps-labplot-back.svg
sc-apps-labplot-cursor-arrow.svg
sc-apps-labplot-editbreaklayout.svg
sc-apps-labplot-editgrid.svg
sc-apps-labplot-edithlayout.svg
sc-apps-labplot-editvlayout.svg
sc-apps-labplot-format-text-symbol.svg
sc-apps-labplot-forward.svg
sc-apps-labplot-json-array.svg
sc-apps-labplot-json-object.svg
sc-apps-labplot-kaggle.svg
sc-apps-labplot-matrix-new.svg
sc-apps-labplot-matrix.svg
sc-apps-labplot-maximize.svg
sc-apps-labplot-minimize.svg
sc-apps-labplot-MQTT.svg
sc-apps-labplot-plot-axis-points.svg
sc-apps-labplot-shift-down-y.svg
sc-apps-labplot-shift-left-x.svg
sc-apps-labplot-shift-right-x.svg
sc-apps-labplot-shift-up-y.svg
sc-apps-labplot-spreadsheet-new.svg
sc-apps-labplot-spreadsheet.svg
sc-apps-labplot-TeX-logo.svg
sc-apps-labplot-transform-move.svg
sc-apps-labplot-workbook-new.svg
sc-apps-labplot-workbook.svg
sc-apps-labplot-worksheet-new.svg
sc-apps-labplot-worksheet.svg
sc-apps-labplot-xy-curve-points.svg
sc-apps-labplot-xy-curve-segments.svg
sc-apps-labplot-xy-curve.svg
sc-apps-labplot-xy-equation-curve.svg
sc-apps-labplot-xy-fit-curve.svg
sc-apps-labplot-xy-plot-four-axes.svg
sc-apps-labplot-xy-plot-two-axes-centered-origin.svg
sc-apps-labplot-xy-plot-two-axes-centered.svg
sc-apps-labplot-xy-plot-two-axes.svg
sc-apps-labplot-zoom-in-x.svg
sc-apps-labplot-zoom-in-y.svg
sc-apps-labplot-zoom-out-x.svg
sc-apps-labplot-zoom-out-y.svg
sc-apps-labplot-zoom-select.svg
sc-apps-labplot-zoom-select-x.svg
sc-apps-labplot-zoom-select-y.svg
sc-apps-labplot-zoom.svg
DESTINATION ${KDE_INSTALL_ICONDIR}
THEME hicolor)
