=== lib/examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)

project(examples)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CI_PROJECT_DIR $ENV{CI_PROJECT_DIR})

cmake_path(GET CI_PROJECT_DIR RELATIVE_PART RELATIVE_CI_PROJECT_DIR)

set(CI_INSTALL_PATH ${CI_PROJECT_DIR}/_staging/${RELATIVE_CI_PROJECT_DIR}/_install)

list(PREPEND CMAKE_SYSTEM_PREFIX_PATH ${CI_INSTALL_PATH})

find_package(LabPlot REQUIRED COMPONENTS SDK)

file(GLOB EXAMPLE_FOLDERS *_ex)
foreach(DIR ${EXAMPLE_FOLDERS})
    add_subdirectory(${DIR})
endforeach()
