=== debian/changelog ===
labplot (2.12.1-2) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Backport upstream commit ee17e7659a97b36b58cab28b2b56cede7cd153c6 to support
    orcus 0.21.0; patch upstream_cmake-support-orcus-0.21.patch.
    (Closes: #1117346)

 -- Pino Toscano <pino@debian.org>  Fri, 14 Nov 2025 22:13:43 +0100

labplot (2.12.1-1) unstable; urgency=medium

  * New upstream release.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Mon, 25 Aug 2025 20:12:49 +0200
