=== debian/control ===
Source: labplot
Section: math
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-sequence-kf6,
 cmake (>= 3.17.0~),
 gettext,
 pkgconf,
 qt6-base-dev (>= 6.5.0~),
 qt6-base-private-dev (>= 6.5.0~),
 qt6-svg-dev (>= 6.5.0~),
 qt6-serialport-dev (>= 6.5.0~),
 extra-cmake-modules (>= 6.3.0~),
 libkf6archive-dev (>= 6.3.0~),
 libkf6completion-dev (>= 6.3.0~),
 libkf6config-dev (>= 6.3.0~),
 libkf6configwidgets-dev (>= 6.3.0~),
 libkf6coreaddons-dev (>= 6.3.0~),
 libkf6crash-dev (>= 6.3.0~),
 libkf6doctools-dev (>= 6.3.0~),
 libkf6i18n-dev (>= 6.3.0~),
 libkf6iconthemes-dev (>= 6.3.0~),
 libkf6kio-dev (>= 6.3.0~),
 libkf6newstuff-dev (>= 6.3.0~),
 libkf6parts-dev (>= 6.3.0~),
 libkf6purpose-dev (>= 6.3.0~),
 libkf6service-dev (>= 6.3.0~),
 libkf6syntaxhighlighting-dev (>= 6.3.0~),
 libkf6textwidgets-dev (>= 6.3.0~),
 libkf6widgetsaddons-dev (>= 6.3.0~),
 libkf6xmlgui-dev (>= 6.3.0~),
 libkf6userfeedback-dev,
 bison,
 libpoppler-qt6-dev (>= 19.12~) [!i386],
 libspectre-dev,
 libcfitsio-dev,
 libgsl-dev,
 libnetcdf-dev,
 libfftw3-dev,
 libhdf5-dev,
 libcerf-dev,
 zlib1g-dev,
 liblz4-dev,
 libmarkdown2-dev,
 libmatio-dev,
 libreadstat-dev,
 libeigen3-dev,
 liborcus-dev,
 libixion-dev,
 libzstd-dev,
 libcantor-dev [!i386],
 xauth <!nocheck>,
 xvfb <!nocheck>,
 locales-all <!nocheck>,
 libqt6sql6-sqlite <!nocheck>,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/labplot
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/labplot.git
Homepage: https://labplot.kde.org/

Package: labplot
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 labplot-data (= ${source:Version}),
Description: interactive graphing and analysis of scientific data
 LabPlot provides an easy way to create, manage and edit plots.  It allows you
 to produce plots based on data from a spreadsheet or on data imported from
 external files.  Plots can be exported to several pixmap and vector graphic
 formats.
 .
 Features include:
  - project-based management of data
  - project explorer for management and organization of created objects in
    different folders and sub-folders
  - spreadsheet with basic functionality for manual data entry or for
    generation of uniform and non-uniform random numbers
  - import of external ASCII data into the project for further editing and
    visualization
  - export of spreadsheet to an ASCII file
  - worksheet as the main parent object for plots, labels, etc; supports
    different layouts and zooming functions
  - export of worksheet to different formats (PDF, EPS, PNG, and SVG)
  - great variety of editing capabilities for properties of worksheet and its
    objects
  - cartesian plots, created either from imported or manually created data
    sets or via mathematical equation
  - definition of mathematical formulas is supported by syntax highlighting
    and completion and by the list of thematically grouped mathematical and
    physical constants and functions
  - analysis of plotted data is supported by many zooming and navigation
    features
  - linear and non-linear fits to data, several fit-models are predefined and
    custom models with arbitrary number of parameters can be provided

Package: labplot-data
Architecture: all
Depends: ${misc:Depends}
Description: data files for labplot
 LabPlot provides an easy way to create, manage and edit plots.  It allows you
 to produce plots based on data from a spreadsheet or on data imported from
 external files.  Plots can be exported to several pixmap and vector graphic
 formats.
 .
 This contains the data files for labplot.
