=== debian/watch ===
version=4
opts="uversionmangle=s/-beta/~beta/;s/-rc/~rc/" \
https://download.kde.org/stable/labplot/labplot-(.+)\.tar\.xz
